/*
 * ui.c
 *
 * Created: 12.12.2016 09:05:25
 *  Author: maddin
 */ 

#include "gui.h"

void gui_init(gui_data_t *gui_data, ssd1306_data_t *ssd_data,  gui_ptr_t gui_array, uint8_t size, uint16_t duration, uint16_t timer)
{
	gui_data->drv		= ssd_data;
	gui_data->gui_array	= gui_array;
	gui_data->count		= size;
	gui_data->current	= 0;	
	gui_data->duration	= duration/timer;
	gui_data->rotate	= 1; 	
}

void gui_update(gui_data_t *gui_data)
{
	static uint16_t counter =0;
	ssd1306_clear(gui_data->drv);			// clear the display
	gui_data->gui_array[gui_data->current]();		// draw the current demo method
	ssd1306_update(gui_data->drv);			// write the buffer to the display

	if (counter > gui_data->duration)
	{ 
		counter =0;
		gui_data->current = (gui_data->current + 1)  % gui_data->count;		 
	}
	if (gui_data->rotate)
	{
		counter++;
	}	
}

void gui_view(gui_data_t *gui_data, gui_ptr_t view)
{
	ssd1306_clear(gui_data->drv);			// clear the display
	view();									// draw the current
	ssd1306_update(gui_data->drv);			// write the buffer to the display

}

void gui_select(gui_data_t *gui_data, uint8_t screen)
{
	gui_data->current = 0;
}

