/*
 * ui.h
 *
 * Created: 12.12.2016 09:05:15
 *  Author: maddin
 */ 


#ifndef GUI_H_
#define GUI_H_



#include <stdlib.h>
#include <avr/io.h>
#include <stdio.h>
#include <stddef.h>
#include <string.h>
#include <avr/interrupt.h>

#include "ssd1306_driver.h"

typedef void (*gui_ptr_t)(void);

typedef struct gui_data_t	{
	ssd1306_data_t	*drv;
	gui_ptr_t		*gui_array;
	uint8_t			current;
	uint8_t			count;
	uint16_t		duration;
	uint8_t			rotate;	
}gui_data_t;



void gui_init(gui_data_t *gui_data, ssd1306_data_t *ssd_data, gui_ptr_t screens, uint8_t size, uint16_t duration, uint16_t timer);
void gui_update(gui_data_t *gui_data);
void gui_view(gui_data_t *gui_data, gui_ptr_t view);
void gui_select(gui_data_t *gui_data, uint8_t screen);

#endif /* GUI_H_ */