/*
 * ui_screens.c
 *
 * Created: 12.12.2016 10:58:54
 *  Author: maddin
 */ 

#include "gui_screens.h"

#include "../main.h"
#include "ssd1306_fonts.h"

char buf[20];  
	
static const char	msg_rn00[] PROGMEM = "|";			
static const char	msg_rn01[] PROGMEM = "/";
static const char	msg_rn02[] PROGMEM = "--";
static const char	msg_rn03[] PROGMEM = "\\";
static PGM_P const	msg_rn[] PROGMEM = { msg_rn00, msg_rn01, msg_rn02, msg_rn03};
		
static const char	msg_wi00[] PROGMEM = "idle";
static const char	msg_wi01[] PROGMEM = "asso";
static const char	msg_wi02[] PROGMEM = "conf";
static const char	msg_wi03[] PROGMEM = "ready";
static const char	msg_wi04[] PROGMEM = "error";
static const char	msg_wi05[] PROGMEM = "disc";
static const char	msg_wi06[] PROGMEM = "noid";
static const char	msg_wi07[] PROGMEM = "undef";
static PGM_P const	msg_wi[] PROGMEM = { msg_wi00, msg_wi01, msg_wi02, msg_wi03, msg_wi04, msg_wi05, msg_wi06, msg_wi07};

static const char	msg_sy00[] PROGMEM = "off";
static const char	msg_sy01[] PROGMEM = "idle";
static const char	msg_sy02[] PROGMEM = "sleep";
static const char	msg_sy03[] PROGMEM = "error";
static PGM_P const	msg_sy[] PROGMEM = {msg_sy00, msg_sy01, msg_sy02, msg_sy03};

static const char	msg_tr00[] PROGMEM = "idle";
static const char	msg_tr01[] PROGMEM = "wake";
static const char	msg_tr02[] PROGMEM = "meas";
static const char	msg_tr03[] PROGMEM = "ready";
static const char	msg_tr04[] PROGMEM = "error";
static PGM_P const	msg_tr[] PROGMEM = {msg_tr00, msg_tr01, msg_tr02, msg_tr03, msg_tr04};
		
static const char	msg_cg00[] PROGMEM = "none";
static const char	msg_cg01[] PROGMEM = "ready";
static const char	msg_cg02[] PROGMEM = "chrg";
static const char	msg_cg03[] PROGMEM = "susp";
static PGM_P const	msg_cg[] PROGMEM = {msg_cg00, msg_cg01, msg_cg02, msg_cg03};

static const char	msg_pg00[] PROGMEM = "";
static const char	msg_pg01[] PROGMEM = "pg";
static PGM_P const	msg_pg[] PROGMEM = {msg_pg00, msg_pg01};
	
static const char	msg_bl00[] PROGMEM = "sleep";
static const char	msg_bl01[] PROGMEM = "idle";
static const char	msg_bl02[] PROGMEM = "bala";
static const char	msg_bl03[] PROGMEM = "error";
static PGM_P const	msg_bl[] PROGMEM = {msg_bl00, msg_bl01, msg_bl02, msg_bl03};

#define FONT  ArialMT_Plain_10

void gui_screenBoot(void)
{
	ssd1306_setTextAlignment(&ssd1306, TEXT_ALIGN_CENTER);
	ssd1306_setFont(&ssd1306, FONT);
	ssd1306_drawString(&ssd1306, 64 , 0, "===== Boot =====");
	
	static uint8_t progress = 0;
	// draw the percentage as String
	char str[8];
	sprintf(str, "%u%%",progress);
	ssd1306_setFont(&ssd1306, FONT);
	ssd1306_setTextAlignment(&ssd1306, TEXT_ALIGN_CENTER);
	ssd1306_drawString(&ssd1306, 64, 10, &str);
	
	// draw the progress bar
	ssd1306_drawProgressBar(&ssd1306, 0, 32, 120, 10, progress);
	progress+=1;
	
	if(progress >100)
		progress=0;
		
}
		
void gui_screen0(void)	
{
	ssd1306_setTextAlignment(&ssd1306, TEXT_ALIGN_CENTER);
	ssd1306_setFont(&ssd1306, FONT);
	ssd1306_drawString(&ssd1306, 64 , 0, "===== INFO =====");
		
	ssd1306_setTextAlignment(&ssd1306, TEXT_ALIGN_LEFT);


	static uint8_t rn=0;
	rn++;
	if (rn>3)	rn=0;
	strcpy_P(buf, pgm_read_word((&msg_rn[rn])));						
	ssd1306_drawString(&ssd1306, 0, 0, buf);	
	
	strcpy_P(buf, (PGM_P)pgm_read_word(&(msg_wi[cfg.wist])));
	if (cfg.wiup)		{ssd1306_drawString(&ssd1306, 0 , 10, ".W"); cfg.wiup = 0;}
	else				 ssd1306_drawString(&ssd1306, 0 , 10, " W");						
	ssd1306_drawString(&ssd1306, 12 , 10, buf);
	
	if (cfg.wiup)		{ssd1306_drawString(&ssd1306, 0 , 20, ".S"); cfg.wiup = 0;}
	else				 ssd1306_drawString(&ssd1306, 0 , 20, " S");						
	ssd1306_drawString(&ssd1306, 12 , 20, buf);
		
	if (cfg.trup)		{ssd1306_drawString(&ssd1306, 0 , 30, ".T"); cfg.trup = 0;}
	else				 ssd1306_drawString(&ssd1306, 0 , 30, " T");						
	strcpy_P(buf, (PGM_P)pgm_read_word(&(msg_tr[cfg.trSt])));	
	ssd1306_drawString(&ssd1306, 12 , 30, buf);


	if (cfg.acpaup)		{ssd1306_drawString(&ssd1306, 0 , 40, ".A"); }
	else				 ssd1306_drawString(&ssd1306, 0 , 40, " A");	
	strcpy_P(buf, (PGM_P)pgm_read_word(&(msg_cg[cfg.acpacg])));	
	ssd1306_drawString(&ssd1306, 12 , 40, buf);
	strcpy_P(buf, (PGM_P)pgm_read_word(&(msg_pg[cfg.acpapg])));
	ssd1306_drawString(&ssd1306, 40 , 40, buf);
		
	//strcpy_P(buf, (PGM_P)pgm_read_word(&(msg_bl[cfg.acpabl])));
	if (cfg.acpaup)		{ssd1306_drawString(&ssd1306, 0 , 50, ".C"); cfg.acpaup = 0;}
	else				 ssd1306_drawString(&ssd1306, 0 , 50, " C");		
	//ssd1306_drawString(&ssd1306, 12 , 50, buf);

	ssd1306_setTextAlignment(&ssd1306, TEXT_ALIGN_RIGHT); 
											
	sprintf(buf, "%s % 3u", cfg.wiip, cfg.wisig);					
	ssd1306_drawString(&ssd1306, 127, 10, buf);
						
	sprintf(buf, "% 3d % 3d % 3d % 3d",cfg.trOfUs,cfg.trVeUs,cfg.trHeUs,cfg.trNeUs);			
	ssd1306_drawString(&ssd1306, 127, 30, buf);	
		
	sprintf(buf, "%1.2f % 3d",cfg.acpamv/1000.0, cfg.acpapr);											
	ssd1306_drawString(&ssd1306, 127, 40, buf);
	
	sprintf(buf, "%1.2f %1.2f %1.2f %1.2f %1.2f",cfg.acc1mv/1000.0,cfg.acc2mv/1000.0,cfg.acc3mv/1000.0 ,cfg.acc4mv/1000.0,cfg.acc5mv/1000.0);
	ssd1306_drawString(&ssd1306, 127, 50, buf);	
	
	
	ssd1306_setColor(&ssd1306,BLACK);
	ssd1306_drawHorizontalLine(&ssd1306, 0, 63, DISPLAY_WIDTH);
	ssd1306_setColor(&ssd1306,WHITE);	
	
	if(cfg.acc1bl) ssd1306_drawHorizontalLine(&ssd1306,  50, 63, 15);
	if(cfg.acc2bl) ssd1306_drawHorizontalLine(&ssd1306,  65, 63, 15);
	if(cfg.acc3bl) ssd1306_drawHorizontalLine(&ssd1306,  80, 63, 15);
	if(cfg.acc4bl) ssd1306_drawHorizontalLine(&ssd1306,  95, 63, 15);
	if(cfg.acc5bl) ssd1306_drawHorizontalLine(&ssd1306, 110, 63, 15);
																		
}
