/*
 * rtc.c
 *
 * Created: 07.10.2016 13:13:07
 *  Author: maddin
 */ 
#include "rtc.h"


volatile uint32_t CountMilliseconds = 0;
	
inline void rtc_isr(void)		// 1ms
{
	CountMilliseconds += 1;
}

void rtc_init(TC0_t *timer)	// timer init
{
	timer->CNT		= 0x00;
	timer->CTRLA	= TC_CLKSEL_DIV1024_gc;				// Vorteiler	1024
	timer->CTRLB	= TC_WGMODE_NORMAL_gc;				// Modus		Normal
	timer->PER		= F_CPU/1024.0f/1000.0f-1.0f;								// Top-Wert		1000 Hz
	timer->INTCTRLA	= TC_OVFINTLVL_LO_gc;
}

uint32_t rtc_set(uint32_t ms)
{
	return(CountMilliseconds + ms - 1);
}

uint8_t rtc_check(uint32_t ms)
{
	//return(((ms - CountMilliseconds) & 0x8000) >> 8);	// 16bit counter
	return((((uint32_t)ms - CountMilliseconds) & 0x80000000) >> 24);		// (ms - SysTickCntHold ) <= tick
}

inline uint32_t rtc_msec(void)
{
	return(CountMilliseconds);
}



//1000 + 500 - 1		1499



