#include "ad5660_driver.h"




//##########################################################################################
void ad5660_init(ad5660_data_t *ad_data, SPI_Master_t *spi, PORT_t *port_cs, uint8_t pin_cs)
{
	ad_data->pin_cs		= pin_cs;
	ad_data->port_cs	= port_cs;
	ad_data->spi		= spi;
	ad_data->val		= 0;
		
	sbi(ad_data->port_cs->OUT, ad_data->pin_cs);		// CS high
	sbi(ad_data->port_cs->DIR, ad_data->pin_cs);		// CS output
	
	ad5660_setOutput(ad_data, AD5660_PWR_NORMAL, 0);
}

//##########################################################################################
void ad5660_setOutput(ad5660_data_t *ad_data, uint8_t mode, uint16_t data)
{
	cbi(ad_data->port_cs->OUT, ad_data->pin_cs);			// SS low
	
	SPI_MasterTransceiveByte(ad_data->spi,mode);			// select PowerDownMode
	// data 0 to 16Bit
	// Vout= 2*Vref*(D/65536)
	SPI_MasterTransceiveByte(ad_data->spi, data >> 8);		// data high
	SPI_MasterTransceiveByte(ad_data->spi, data & 0xff);	// data low
	
	sbi(ad_data->port_cs->OUT, ad_data->pin_cs);			// SS high	
}

//##########################################################################################

