#ifndef AD5660_DRIVER_H_
#define AD5660_DRIVER_H_


#include <stdlib.h>
#include <avr/io.h>
#include <stdio.h>
#include <stddef.h>
#include <avr/interrupt.h>


#include "spi_driver.h"
#include "macros.h"

// SPI SCK  max 10MHz

//######################################## Struct
typedef struct ad5660_data_t	{
	uint8_t			pin_cs;
	PORT_t			*port_cs;
	SPI_Master_t	*spi;
	double			val;
}ad5660_data_t;

//######################################## Register
#define AD5660_PWR_NORMAL		0b00000000
#define AD5660_PWR_1KTOGND		0b00000001
#define AD5660_PWR_100KTOGND	0b00000010
#define AD5660_PWR_3STATE		0b00000011


//######################################## Functions
void	ad5660_init(ad5660_data_t *ad_data, SPI_Master_t *spi, PORT_t *port_cs, uint8_t pin_cs);
void	ad5660_setOutput(ad5660_data_t *ad_data, uint8_t mode, uint16_t data);


#endif /* AD5660_DRIVER_H_ */