/*#################################################################################################
	For		:	Xmega 
	Version	:	1.0
	Date	:	30.07.2013
	Autor	:	Martin Junghans
	Hardware:	ATXmega128A3-U, 32MHz at 16Mhz extern
//################################################################################################*/
#ifndef MACROS_H
#define MACROS_H

#define FALSE	0
#define TRUE	1

#define ARRAY_SIZE(X) (sizeof(X) / sizeof(*(X)))

//#################################### Macros
#define uniq(LOW,HEIGHT)	(HEIGHT << 8)|LOW		// 2x 8Bit 	--> 16Bit
#define LOW_BYTE(x)        	(x & 0xff)				// 16Bit 	--> 8Bit
#define HIG_BYTE(x)       	(x >> 8) & 0xff			// 16Bit 	--> 8Bit


#define sbi(ADDRESS,BIT) 	ADDRESS |= (1<<BIT)		// set Bit
#define cbi(ADDRESS,BIT) 	ADDRESS &= ~(1<<BIT)	// clear Bit
#define	toggle(ADDRESS,BIT)	ADDRESS ^= (1<<BIT)		// Bit umschalten

#define	bis(ADDRESS,BIT)	ADDRESS & (1<<BIT)		// bit is set?
#define	bic(ADDRESS,BIT)	!(ADDRESS & (1<<BIT))	// bit is clear?

// side-effect safe forms of min and max
#ifndef max
#define max(a,b) \
({ __typeof__ (a) termA = (a); \
	__typeof__ (b) termB = (b); \
termA>termB ? termA:termB; })
#endif

#ifndef min
#define min(a,b) \
({ __typeof__ (a) termA = (a); \
	__typeof__ (b) termB = (b); \
termA<termB ? termA:termB; })
#endif

#ifndef avg
#define avg(a,b) ((a+b)/2)
#endif

//####################################
#endif
